searchData={"items":[{"type":"module","title":"Alarmist","doc":"Alarm manager","ref":"Alarmist.html"},{"type":"function","title":"Alarmist.add_synthetic_alarm/1","doc":"Add a rule-based alarm\n\nAfter this call, Alarmist will watch for alarms to be set based on the\nsupplied rules and set or clear the specified alarm ID. The alarm ID\nneeds to be unique.","ref":"Alarmist.html#add_synthetic_alarm/1"},{"type":"function","title":"Alarmist.add_synthetic_alarm/2","doc":"Manually add a rule-based alarm\n\nUse this when not using `defalarm`.\n\nAfter this call, Alarmist will watch for alarms to be set based on the\nsupplied rules and set or clear the specified alarm ID. The alarm ID\nneeds to be unique.","ref":"Alarmist.html#add_synthetic_alarm/2"},{"type":"function","title":"Alarmist.get_alarm_ids/0","doc":"Return a list of all active alarm IDs","ref":"Alarmist.html#get_alarm_ids/0"},{"type":"function","title":"Alarmist.get_alarms/0","doc":"Return a list of all active alarms\n\nThis returns `{id, description}` tuples. Note that `Alarmist` normalizes\nalarms that were not set as 2-tuples so this may not match calls to\n`:alarm_handler.set_alarm/1` exactly.","ref":"Alarmist.html#get_alarms/0"},{"type":"function","title":"Alarmist.remove_synthetic_alarm/1","doc":"Manually add a rule-based alarm\n\nUse this when not using `defalarm`.\n\nAfter this call, Alarmist will watch for alarms to be set based on the\nsupplied rules and set or clear the specified alarm ID. The alarm ID\nneeds to be unique.","ref":"Alarmist.html#remove_synthetic_alarm/1"},{"type":"function","title":"Alarmist.subscribe/1","doc":"Subscribe to alarm status events\n\nEvents will be delivered to the calling process as:\n\n```elixir\n%Alarmist.Event{\n  id: TheAlarmId,\n  state: :set,\n  description: nil,\n  timestamp: -576460712978320952,\n  previous_state: :unknown,\n  previous_timestamp: -576460751417398083\n}\n```","ref":"Alarmist.html#subscribe/1"},{"type":"function","title":"Alarmist.unsubscribe/1","doc":"Unsubscribe the current process from the specified alarm `:set` and `:clear` events","ref":"Alarmist.html#unsubscribe/1"},{"type":"type","title":"Alarmist.alarm/0","doc":"Alarm information\n\nCalls to `:alarm_handler.set_alarm/1` pass an alarm identifier and\ndescription as a 2-tuple. Alarmist stores the description of the most recent\ncall.\n\n`:alarm_handler.set_alarm/1` doesn't enforce the use of 2-tuples. Alarmist\nnormalizes non-2-tuple alarms so that they have empty descriptions.","ref":"Alarmist.html#t:alarm/0"},{"type":"type","title":"Alarmist.alarm_description/0","doc":"Alarm description\n\nThis is optional supplemental information about the alarm. It could contain\nmore information about why it was set. Don't use it to differentiate between\nalarms. Use the alarm ID for that.","ref":"Alarmist.html#t:alarm_description/0"},{"type":"type","title":"Alarmist.alarm_id/0","doc":"Alarm identifier\n\nAlarm identifiers are the unique identifiers of each alarm that can be\nset or cleared.\n\nWhile SASL alarm identifiers can be anything, Alarmist imposes the restriction\nthat they all be atoms. It is highly recommended to use module names to\navoid naming collisions. Non-atom alarms are currently ignored by Alarmist.","ref":"Alarmist.html#t:alarm_id/0"},{"type":"type","title":"Alarmist.alarm_state/0","doc":"Alarm state\n\nAlarms are in the `:set` state after a call to `:alarm_handler.set_alarm/1`\nand in the `:clear` state after a call to `:alarm_handler.clear_alarm/1`.\nRedundant calls to `:alarm_handler.set_alarm/1` update the alarm description\nand redundant calls to `:alarm_handler.clear_alarm/1` are ignored.","ref":"Alarmist.html#t:alarm_state/0"},{"type":"type","title":"Alarmist.compiled_rules/0","doc":"","ref":"Alarmist.html#t:compiled_rules/0"},{"type":"module","title":"Alarmist.Compiler","doc":"Compile rule specifications","ref":"Alarmist.Compiler.html"},{"type":"function","title":"Alarmist.Compiler.compile/2","doc":"","ref":"Alarmist.Compiler.html#compile/2"},{"type":"type","title":"Alarmist.Compiler.rule/0","doc":"","ref":"Alarmist.Compiler.html#t:rule/0"},{"type":"type","title":"Alarmist.Compiler.rule_spec/0","doc":"","ref":"Alarmist.Compiler.html#t:rule_spec/0"},{"type":"module","title":"Alarmist.Engine","doc":"Synthetic alarm processing engine","ref":"Alarmist.Engine.html"},{"type":"function","title":"Alarmist.Engine.add_synthetic_alarm/3","doc":"Create and add a synthetic alarm based on the rule specification\n\nThe synthetic alarm will be evaluated, so if the synthetic alarm ID already\nhas subscribers, they'll get notified if the alarm is set.\n\nRaises on errors","ref":"Alarmist.Engine.html#add_synthetic_alarm/3"},{"type":"function","title":"Alarmist.Engine.cache_put/4","doc":"Cache alarm state and record the change\n\nIMPORTANT: Rules are evaluated on the next call to `run/2` if there was a change.","ref":"Alarmist.Engine.html#cache_put/4"},{"type":"function","title":"Alarmist.Engine.clear_alarm/2","doc":"","ref":"Alarmist.Engine.html#clear_alarm/2"},{"type":"function","title":"Alarmist.Engine.commit_side_effects/1","doc":"Commit all side effects from previous operations\n\nThe caller needs to run all of the side effects before the next call to the engine\nso state changes may be lost.","ref":"Alarmist.Engine.html#commit_side_effects/1"},{"type":"function","title":"Alarmist.Engine.handle_timeout/4","doc":"","ref":"Alarmist.Engine.html#handle_timeout/4"},{"type":"function","title":"Alarmist.Engine.init/1","doc":"","ref":"Alarmist.Engine.html#init/1"},{"type":"function","title":"Alarmist.Engine.remove_synthetic_alarm/2","doc":"Remove all of the rules associated with the specified id","ref":"Alarmist.Engine.html#remove_synthetic_alarm/2"},{"type":"function","title":"Alarmist.Engine.set_alarm/3","doc":"Report that an alarm_id has changed state","ref":"Alarmist.Engine.html#set_alarm/3"},{"type":"type","title":"Alarmist.Engine.action/0","doc":"","ref":"Alarmist.Engine.html#t:action/0"},{"type":"type","title":"Alarmist.Engine.alarm_lookup_fun/0","doc":"","ref":"Alarmist.Engine.html#t:alarm_lookup_fun/0"},{"type":"type","title":"Alarmist.Engine.t/0","doc":"* `:alarm_id_to_rules` - map of alarm_id to the list of rules to run\n* `:cache` - temporary cache for alarm status while processing rules\n* `:changed_alarm_id` - list of alarm_ids that have changed values\n* `:timers` - map of alarm_id to pending timer\n* `:actions_r` - list of pending side effects in reverse (engine processing is side-effect free\n  by design so someone else has to do the dirty work)\n* `:states` - optional state that can be kept on a per-alarm_id basis\n* `:lookup_fun` - function for looking up alarm state","ref":"Alarmist.Engine.html#t:t/0"},{"type":"module","title":"Alarmist.Event","doc":"Struct sent to subscribers on property changes\n\n* `:id` - which alarm\n* `:state` - `:set` or `:clear`\n* `:description` - alarm description or `nil` when the alarm has been cleared\n* `:timestamp` - the timestamp (`System.monotonic_time/0`) when the changed happened\n* `:previous_state` - the previous value (`:unknown` if no previous information)\n* `:previous_timestamp` - the timestamp when the property changed to\n  `:previous_state`. Use this to calculate how long the property was the\n  previous state.","ref":"Alarmist.Event.html"},{"type":"type","title":"Alarmist.Event.t/0","doc":"","ref":"Alarmist.Event.html#t:t/0"},{"type":"module","title":"Alarmist.Handler","doc":"Alarm handler","ref":"Alarmist.Handler.html"},{"type":"function","title":"Alarmist.Handler.add_synthetic_alarm/2","doc":"","ref":"Alarmist.Handler.html#add_synthetic_alarm/2"},{"type":"function","title":"Alarmist.Handler.get_state/0","doc":"","ref":"Alarmist.Handler.html#get_state/0"},{"type":"function","title":"Alarmist.Handler.handle_event/2","doc":"Registers a new alarm rule at runtime, registering rules with application config is preferred over this.","ref":"Alarmist.Handler.html#handle_event/2"},{"type":"function","title":"Alarmist.Handler.remove_synthetic_alarm/1","doc":"","ref":"Alarmist.Handler.html#remove_synthetic_alarm/1"},{"type":"module","title":"Alarmist.Matcher","doc":"Match logic using atom-based keys used in PropertyTable.\nBasically it's `PropertyTable.Matcher.StringPath` but using atoms instead of strings.","ref":"Alarmist.Matcher.html"},{"type":"function","title":"Alarmist.Matcher.check_pattern/1","doc":"Check whether a pattern is valid\n\nReturns `:ok` on success or `{:error, error}` where `error` is an `Exception` struct with\ninformation about the issue.","ref":"Alarmist.Matcher.html#check_pattern/1"},{"type":"function","title":"Alarmist.Matcher.check_property/1","doc":"Check whether a property is valid\n\nReturns `:ok` on success or `{:error, error}` where `error` is an `Exception` struct with\ninformation about the issue.","ref":"Alarmist.Matcher.html#check_property/1"},{"type":"function","title":"Alarmist.Matcher.matches?/2","doc":"Returns true if the pattern matches the specified property","ref":"Alarmist.Matcher.html#matches?/2"},{"type":"module","title":"Alarmist.Ops","doc":"Derivative alarm generation operations","ref":"Alarmist.Ops.html"},{"type":"function","title":"Alarmist.Ops.copy/2","doc":"Replicate an alarm status\n\nThis is useful for aliasing alarm names. For example, if one library sets and\nclears an alarm ID that's in its namespace, but another library wants to\nlisten on changes to an alarm ID in its namespace, a copy rule can glue them\ntogether.","ref":"Alarmist.Ops.html#copy/2"},{"type":"function","title":"Alarmist.Ops.debounce/2","doc":"Set an alarm when the input has been set for a specified duration\n\nThis rule removes transient alarms from triggering remediation unnecessarily.\nThis is useful when remediation is expensive or service impacting and the\ninput alarm is somewhat glitchy.\n\nAlarmist already provides some debouncing since alarms that get set and\ncleared in one alarm processing pass are ignored already. This is unreliable,\nthough, and a debounce rule establishes a duration.\n\nAn example of when debouncing is useful is to delay remediation of higher\nlevel alarms like being disconnected from a backend server. There are many\nreasons that a TCP connection could be interrupted and client code probably\nhas some retry logic in it already to reestablish the connection. In this\ncase, it might be good to delay switching to an offline mode for a little bit\nin the hopes that the problem will naturally go away.","ref":"Alarmist.Ops.html#debounce/2"},{"type":"function","title":"Alarmist.Ops.hold/2","doc":"Keep an alarm set for a guaranteed amount of time\n\nThis sets an alarm for at least `timeout` milliseconds after it is set. Each\ntime the alarm is set, the timer is restarted.\n\nHold is useful for types of remediation that are time based. I.e., handling\nan alarm means turning something off for a while since turning that feature\nback on when the alarm gets cleared would likely just result in the alarm\nbeing set again. Managing the timeout period via alarms rather than\nprogrammatically lets you manually clear the alarm if you'd like that feature\nenabled again immediately like if you're debugging.","ref":"Alarmist.Ops.html#hold/2"},{"type":"function","title":"Alarmist.Ops.intensity/2","doc":"Sets an alarm when the input alarm has been set and cleared too many times\n\nThis type of rule catches flapping alarms where it's desirable to take some\nkind of remediation when they trigger too many times in a row. Intensity is\nmeasured as `count` set/clears in `duration` milliseconds. This is the same\nas supervision restart intensity thresholds.\n\nAn example of an intensity-based alarm is to handle the case when multiple\nnetwork connections are available, but one that should be good is flakey.\nThis happens if a device has both a cellular and a WiFi connection. Normally\nthe WiFi connection is preferred, but if it keeps going up and down, it may\nbe desirable to raise an alarm. That alarm could disable WiFi for a while.\nCombine this with `hold/2` to manage the duration that WiFi is off.","ref":"Alarmist.Ops.html#intensity/2"},{"type":"function","title":"Alarmist.Ops.logical_and/2","doc":"Set an alarm when all of the input alarms are set\n\nThis is useful when remediation is only useful when a lot of things go wrong.\nFor example, if a device has more than one way of accomplishing a task, there\ncould be a specific remediation when one way stops working. However, if every\nway is broken, the device could trigger a more significant remediation.","ref":"Alarmist.Ops.html#logical_and/2"},{"type":"function","title":"Alarmist.Ops.logical_not/2","doc":"Set an alarm when the input alarm is cleared\n\nThis is useful for \"proof-of-life\" alarms where the presence of an alarm is a\ngood thing.","ref":"Alarmist.Ops.html#logical_not/2"},{"type":"function","title":"Alarmist.Ops.logical_or/2","doc":"Set an alarm when one or more input alarms get set\n\nThis is useful for triggering a generic remediation. An example of this for\nsetting an alarm that indicates that the device is \"unhealthy\" and needs to\nreboot. There are usually many disastrous alarms that when raised really have\nno great remediation other than reboot. This allows a handler to register for\na combined alarm so that it's decoupled from the alarms that trigger it.","ref":"Alarmist.Ops.html#logical_or/2"},{"type":"extras","title":"Alarmist","doc":"# Alarmist\n\n[![Hex version](https://img.shields.io/hexpm/v/alarmist.svg \"Hex version\")](https://hex.pm/packages/alarmist)\n[![API docs](https://img.shields.io/hexpm/v/alarmist.svg?label=hexdocs \"API docs\")](https://hexdocs.pm/alarmist/Alarmist.html)\n[![CircleCI](https://circleci.com/gh/smartrent/alarmist.svg?style=svg)](https://circleci.com/gh/smartrent/alarmist)\n\nAlarmist extends Erlang's [Alarm\nHandler](https://www.erlang.org/doc/man/alarm_handler) to manage, subscribe to,\nand create synthetic alarms. Code that sets and clears alarms need only depend\non `:alarm_handler`. Alarmist is for the side that has to deal with alarms.","ref":"readme.html"},{"type":"extras","title":"What are alarms - Alarmist","doc":"Alarms are different from events. While events can convey any information, an\nalarm conveys a boolean state. The alarm can either be `set` or `clear`. Code\nshould always be able to know the state of the alarm. With events, you either\nget the event or not. There may be ways of obtaining the event when it's missed,\nbut with alarms there's an expectation that the alarm state is always\naccessible.\n\nErlang's Alarm Handler allows code that sets alarms to include supplementary\ninformation called `AlarmDescription`. This is purely informational. If an alarm\nis set more than once, only the latest description is available. It is not\nuseful for differentiating alarms. For example, a network disconnected alarm\nshould incorporate the network interface name (`eth0`) into the `AlarmId` rather\nthan the `AlarmDescription`.","ref":"readme.html#what-are-alarms"},{"type":"extras","title":"When to use alarms - Alarmist","doc":"Alarms are one tool in the fault management toolbox. They give a name to\npersistent conditions that are involved with non-local remediation to clear.\n\nPersistent in this sense means that the alarm continues to exist until reported\notherwise. It is not transient. For example, a supervised GenServer that crashes\nis a transient fault since its supervisor is going to restart it. An issue like\na remote server no longer being reachable is persistent. It may become reachable\nin a few seconds or hours or more.\n\nNon-local remediation means that the code that sets the alarm does so to either\nhelp or get help from somewhere else like another library or a person. For\nexample, code that monitors a network connection could set an alarm when the\ninternet is unreachable so that UI code could show the issue to a nearby human.","ref":"readme.html#when-to-use-alarms"},{"type":"extras","title":"Naming alarms - Alarmist","doc":"Erlang's Alarm Handler allows `AlarmId`'s to be any Erlang term. While super\nflexible, it's also helpful to have a convention.\n\nFor Elixir code, name alarms as you would a module. If you have helper functions\nfor `AlarmDescription` data, then put those functions in a `defmodule` of the\nsame name as the alarm. This is optional, so there's no need to create an empty\nmodule if you don't have helper functions.\n\nFor libraries, alarms are public API. There's no explicit place for alarms in\nHex documentation, so add them where you think best. The important parts are to\ndocument the alarms name, when it's set and cleared, and the type and content of\nthe `AlarmDescription` data.\n\nErlang code should use Erlang conventions for naming modules.\n\n**Using 2-tuples for `AlarmId`'s so that you can have generic alarms is not\nsupported by `Alarmist`, but probably will be added. I.e. `{NetworkDown,\n\"eth0\"}`**","ref":"readme.html#naming-alarms"},{"type":"extras","title":"Synthetic alarms - Alarmist","doc":"One of the major features of `Alarmist` is to support creating new alarms that\nget set and cleared based on the status of other alarms. This simplifies alarm\nhandling code since it's often the case that you don't want to trigger a\nremediation immediately or a remediation may only be useful if some combination\nof alarms are set. Another advantage of creating synthetic alarms is that it\nincreases the visibility of when these more complex alarms trigger so that you\ndon't need to dig through the alarm handling code to know whether conditions\nhave met the remediation criteria or not.\n\nAs before, networking issues make good examples. Home and business networks have\nsome normal flakiness that doesn't require remediation. Sometimes just waiting a\nbit resolves a situation. Code that detects a network outage can simply set an\nalarm stating it is down. `Alarmist` provides primitives for creating a\nsynthetic alarm that doesn't get set unless the network is down longer than a\nminimum amount of time. `Alarmist` can also raise an alarm if the network is\nbouncing up and down a lot since that's also problematic, but in a way that the\nminimum time criteria wouldn't detect.\n\nTo make synthetic alarms easy to create, `Alarmist` provides the `defalarm`\nmacro. The general form is to create a module with the name of the synthetic\nalarm you're creating and then use `defalarm` to express the criteria for it\nbeing set:\n\n```elixir\ndefmodule MyNewAlarm do\n  use Alarmist.Definition\n\n  defalarm do\n    InterestingAlarm1 and InterestingAlarm2\n  end\nend\n```\n\nIn this example, `MyNewAlarm` will be set only when both `InterestingAlarm1` and\n`InterestingAlarm2` are set.\n\nThe following sections describe the operators available for synthetic alarms.","ref":"readme.html#synthetic-alarms"},{"type":"extras","title":"Identity - Alarmist","doc":"Specifying an `AlarmId` by itself creates a new alarm whose state mirrors the\noriginal one. In other words, it creates an alias and is useful for decoupling\nthe naming of alarms between projects.\n\n```elixir\ndefmodule IdenticalAlarm do\n  use Alarmist.Definition\n\n  defalarm do\n    SomeOtherAlarmName\n  end\nend\n```","ref":"readme.html#identity"},{"type":"extras","title":"Debounce - Alarmist","doc":"The `debounce/2` function specifies a minimum amount of time for another alarm\nto be set before it is set. This can be used to delay remediation if there's a\nchance that the alarm goes away on its own.\n\n```elixir\ndefmodule RealProblemAlarm do\n  use Alarmist.Definition\n\n  defalarm do\n    # Set this module's alarm when FlakyAlarm has been set for at for 5 seconds\n    debounce(FlakyAlarm, 5_000)\n  end\nend\n```","ref":"readme.html#debounce"},{"type":"extras","title":"Hold - Alarmist","doc":"The `hold/2` function specifies a minimum amount of time for the new alarm to be\nset. For example, if an alarm triggers an indicator on a UI, then it may need to\nstay on for a minimum duration. While the UI could have the timer, creating an\nalarm lets other code or alarms change their behavior as well.\n\n```elixir\ndefmodule LongerAlarm do\n  use Alarmist.Definition\n\n  defalarm do\n    # Set the alarm for at least 3 seconds whenever FlakyAlarm\n    hold(FlakyAlarm, 3_000)\n  end\nend\n```","ref":"readme.html#hold"},{"type":"extras","title":"Intensity - Alarmist","doc":"The `intensity/3` function sets an alarm when another has been set and cleared\ntoo many times in a row. The metric is set/cleared x times in y milliseconds\nsimilar to OTP's supervisor restart intensity parameters. It can be useful to\ncombine `intensity/3` with `hold/2` to create an alarm that disables a feature\nfor a short time when it flaps too much. Some people call this a penalty box.\n\n```elixir\ndefmodule IntensityThresholdAlarm do\n  use Alarmist.Definition\n\n  defalarm do\n    # Set when raised and cleared >= 5 times in 3 seconds\n    intensity(FlakyAlarm, 5, 3_000)\n  end\nend\n```","ref":"readme.html#intensity"},{"type":"extras","title":"Boolean logic - Alarmist","doc":"Standard Elixir boolean operators like `and`, `or`, and `not` can be used to\ncombine and group multiple alarms. This is an easy way to create an alarm that\ntracks exactly what you want.\n\n```elixir\ndefmodule IntensityThresholdAlarm do\n  use Alarmist.Definition\n\n  defalarm do\n    (Alarm1 or Alarm2) and intensity(FlakyAlarm, 5, 10_000)\n  end\nend\n```","ref":"readme.html#boolean-logic"},{"type":"extras","title":"Example - Alarmist","doc":"The following example shows how to define an alarm that WiFi is unstable based\non a alarm that says when WiFi is down. This is a real life example of an\nembedded device with an expensive backup cellular connection. WiFi can be flaky,\nthough, so you wouldn't want to turn on the cellular connection right when WiFi\ngoes down since that might be a hiccup.\n\nThe following code defines a synthetic alarm for unstable WiFi,\n`Demo.WiFiUnstable`. The timeouts are short to make it easier to copy/paste into\nan IEx prompt and manually run.\n\n```elixir\ndefmodule Demo.WiFiUnstable do\n  @moduledoc \"\"\"\n  Alarm for when WiFi bounces too frequently\n  \"\"\"\n  use Alarmist.Definition\n\n  # WiFi must be down for at least 15 seconds or flapped 2 times in 60 seconds\n  defalarm do\n    debounce(Demo.WiFiDown, :timer.seconds(15)) or\n      intensity(Demo.WiFiDown, 2, :timer.seconds(60))\n  end\nend\n\ndefmodule Demo do\n  @moduledoc \"\"\"\n  Helpers for setting and clearing alarms\n  \"\"\"\n  def wifi_down() do\n    :alarm_handler.set_alarm({Demo.WiFiDown, nil})\n  end\n\n  def wifi_up() do\n    :alarm_handler.clear_alarm(Demo.WiFiDown)\n  end\n\n  def wifi_flap() do\n    wifi_down()\n    wifi_up()\n    wifi_down()\n    wifi_up()\n  end\nend\n```\n\nNow that we have alarm logic and helpers defined the synthetic alarm needs to be\nregistered:\n\n```elixir\n  # ... normally in an Application.start or other code that runs on init ...\n  Alarmist.add_synthetic_alarm(Demo.WiFiUnstable)\n```\n\nThen subscribe for notifications:\n\n```elixir\n  # ... normally in the GenServer with the remediation code...\n  Alarmist.subscribe(Demo.WiFiUnstable)\n```\n\nFinally, we can exercise setting and clearing the alarm:\n\n```elixir\niex> Demo.wifi_flap\n:ok\niex> flush\n%Alarmist.Event{\n  id: Demo.WiFiUnstable,\n  state: :set,\n  description: nil,\n  timestamp: -576460712978320952,\n  previous_state: :unknown,\n  previous_timestamp: -576460751417398083\n}\n:ok\n# Wait ~60 seconds\niex> flush\n%Alarmist.Event{\n  id: Demo.WiFiUnstable,\n  state: :clear,\n  timestamp: -576460652977733801,\n  previous_state: :set,\n  previous_timestamp: -576460712978320952\n}\n```","ref":"readme.html#example"},{"type":"extras","title":"License - Alarmist","doc":"Alarmist is licensed under the Apache License, Version 2.0.","ref":"readme.html#license"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nThis project follows [Semantic Versioning](https://semver.org/spec/v2.0.0.html).","ref":"changelog.html"},{"type":"extras","title":"v0.2.0 - 2024-12-09 - Changelog","doc":"This is a backwards incompatible update. The following changes are needed:\n\n1. Replace all calls to `Alarmist.current_alarms/0` with\n   `Alarmist.get_alarm_ids/0`. This is a hard deprecation.\n2. Update all message handling on Alarmist events to expect and use the\n   `Alarmist.Event.t()`. In most usage, this means matching on `:id` and\n   `:state` and it should simplify the handling functions.\n\n* Updates\n  * Simplify the API by completely abstracting away the internal implementation\n    with uses the PropertyTables library. This will allow for further internal\n    improvements without forcing breaking changes.\n  * Align the API for getting alarms with `:alarm_handler`. This added the\n    `Alarmist.get_alarms/0` function.\n  * Remove a race condition involving the use of alarm descriptions.\n    Descriptions are sent to subscribers with the alarm status change\n    notification now.\n  * Use one timestamp value for all alarms that were set at initialization time.\n    This removes the ambiguity of whether an alarm changed a few milliseconds\n    after Alarmist start up or was one of the original alarms.\n  * Report when alarms are in an `:unknown` state when no information is\n    available. This is useful for the `:previous_state` field in alarm events.","ref":"changelog.html#v0-2-0-2024-12-09"},{"type":"extras","title":"v0.1.3 - 2024-09-26 - Changelog","doc":"* Updates\n  * Don't crash on non-atom Alarm IDs. Alarmist doesn't support these yet so\n    they're currently ignored.","ref":"changelog.html#v0-1-3-2024-09-26"},{"type":"extras","title":"v0.1.2 - 2024-03-04 - Changelog","doc":"First public release","ref":"changelog.html#v0-1-2-2024-03-04"},{"type":"extras","title":"v0.1.1 - 2024-02-29 - Changelog","doc":"* Updates\n  * Delay swapping alarm handler until supervision tree started to fix possible\n    crash on startup","ref":"changelog.html#v0-1-1-2024-02-29"},{"type":"extras","title":"v0.1.0 - 2024-01-19 - Changelog","doc":"Initial release","ref":"changelog.html#v0-1-0-2024-01-19"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.35.1"}}